Subject: bug#77809: adding next-error support for flymake diagnostics buffers

From: Eli Zaretskii <[email-masked]>
Date: Sun, 27 Apr 2025 10:40:19 +0300

> From: Matthew Tromp <[email-masked]>
> Date: Fri, 25 Apr 2025 13:43:57 -0400
> Cc: Spencer Baugh <[email-masked]>, [email-masked]
> 
> Here you go
> 
> On Wed, Apr 23, 2025 at 7:46 AM Eli Zaretskii <[email-masked]> wrote:
> >
> > > From: Spencer Baugh <[email-masked]>
> > > Cc: [email-masked],  Eli Zaretskii <[email-masked]>
> > > Date: Tue, 22 Apr 2025 15:37:49 -0400
> > >
> > > I think this is ready to be installed.  I went ahead and updated your
> > > commit message to include a changelog entry - please include that in
> > > future changes, see "Generating ChangeLog entries" in CONTRIBUTE.
> > >
> > > Eli, can you please install the attached change?
> >
> > See below.
> >
> > > +(defvar-local flymake-current-diagnostic-line 0
> > > +  "The line of the most recently focused diagnostic in the flymake
> > > +diagnostics buffer.")
> >
> > The first line of a doc string should be a single complete sentence.
> >
> > > +(defun flymake--diagnostics-next-error (n &optional reset)
> > > +  "`next-error-function' for flymake diagnostics buffers.
> > > +N is an integer representing how many errors to move.
> > > +If RESET is non-nil, returns to the beginning of the errors before
> >                         ^^^^^^^
> > "return"
> >
> > Thanks.

Thanks.  Byte-compiling the modified flymake.el produces this warning:

    ELC      progmodes/flymake.elc

  In flymake--diagnostics-next-error:
  progmodes/flymake.el:2111:6: Warning: `when-let' is an obsolete macro (as of 31.1); use `when-let*' or `and-let*' instead.

Could you please fix the code to avoid this warning?

Also, you don't seem to have copyright assignment on file.  So we can
accept this contribution from you, but any further contributions will
require that you do the paperwork of assigning the copyright to the
FSF.  If you agree, I will send you the form to fill and the
instructions to go with them, so you could get your legal paperwork
rolling.

Thanks.